{$IFDEF FPC}
{$MODE DELPHI}
{$ENDIF}

program ShutDownWin;
{$R ShutDown}


uses
  windows,
  messages,
  rasapi,
  shellapi;



type
  ToolInfoA = packed record
    cbSize: UINT;
    uFlags: UINT;
    hwnd: HWND;
    uId: LRESULT; //Compatibility hacks in many places: LRESULT works from Delphi5 to Delphi XE6 and FreePascal x86/x64
    Rect: TRect;
    hInst: THandle;
    lpszText: PAnsiChar;
    lParam: LPARAM;
  end;

var
  porig: LRESULT;
  falmsg: TMsg;
  globwindow, dlgmodeless, toolt, net: HWND;
  re: LpRasEntryNameA;
  rc: LpRasConnA;
  lpcb, lpcentries, lpconns: Longint;
  boot: Word;
  du1, du2: string[2];
  bo1, bo2, netonly: BOOL;
  // ConfigProc: TFarProc;
  ora, perc: Word;
  tim: Integer;
  syst: SYSTEMTIME;
  idat: _NOTIFYICONDATAA;
  toolinf: ToolInfoA;
  fstart: BOOL = True;

const
  TOOLTIPS_CLASS = 'tooltips_class32';
  TTS_ALWAYSTIP   = $01;
  TTF_IDISHWND    = $0001;
  TTM_ADDTOOLA     = WM_USER + 4;
  TTM_RELAYEVENT  = WM_USER + 7;
  SUSPEND = 66;
  OSZTALYNEV = 'SDWClass1';

{$IFDEF FPC}
  ID_Cancel = IDCancel;
  function SetSystemPowerState(fSuspend, fForce: BOOL): BOOL; stdcall; external 'kernel32.dll';
{$ENDIF}

procedure InitCommonControls; stdcall; external 'comctl32.dll';

function strpcopy(d: PAnsiChar; const s: AnsiString): PAnsiChar;
var
  counter: Byte;
  len: Integer;
begin
  if s = '' then
  begin
    d[0] := #0;
    StrPCopy := d;
    exit;
  end;
  len := length(s);
  for counter := 1 to len do
    d[counter - 1] := s[counter];

  d[len] := #0;
  StrPCopy := d;
end;

function subproc(window: HWND; message:UINT; wparam:WPARAM; lparam:LPARAM): LRESULT; export; stdcall;
begin
  case message of
    WM_Mousemove:
      begin

        falmsg.hwnd := net;
        falmsg.message := WM_mousemove;
        falmsg.wparam := wparam;
        falmsg.lparam := lparam;
        sendmessage(toolt, TTM_RELAYEVENT, 0, LRESULT(@falmsg));
      end;
  end;
  subproc := callwindowproc(pointer(porig), window, message, wparam, lparam);

end;

function config(dialog: HWND; message:UINT; wparam:WPARAM; lparam:LPARAM): BOOL; export; stdcall;

begin
  config := True;
  case Message of

    WM_Initdialog:
      begin
        netonly := False;

        initcommoncontrols;
        toolt := createwindowex(0, TOOLTIPS_CLASS, nil, TTS_ALWAYSTIP, 1, 1, 1, 1, 0, 0, HInstance, nil);
        net := getdlgitem(dialog, 904);
       {$IFDEF WIN64}
        porig := setwindowlongptr(net, GWL_WNDPROC, LRESULT(@subproc));
       {$ELSE}
        porig := setwindowlong(net, GWL_WNDPROC, LRESULT(@subproc));
       {$ENDIF}
        toolinf.cbsize := sizeof(ToolInfoA);
        toolinf.uflags := TTF_IDISHWND;
        toolinf.hwnd := dialog;
        toolinf.uid := net;
        toolinf.lpsztext := ' Terminate Dialup Connections and leave System alone';
        sendmessage(toolt, TTM_ADDTOOLA, 0, LRESULT(@toolinf));

        checkdlgbutton(dialog, 904, 0);
        //enablewindow(getdlgitem(dialog,905),False);
        senddlgitemmessage(dialog, 901, EM_LIMITTEXT, 2, 0);
        senddlgitemmessage(dialog, 902, EM_LIMITTEXT, 2, 0);
        exit;
      end;

    WM_Destroy:
      begin
        setwindowlong(net, GWL_WNDPROC, porig);
      end;

    WM_Command:
      begin

        if wparam = 905 then
        begin
          if isdlgbuttonchecked(dialog, 905) = BST_CHECKED then
            checkdlgbutton(dialog, 906, BST_UNCHECKED);
          exit;
        end;

        if wparam = 906 then
        begin
          if isdlgbuttonchecked(dialog, 906) = BST_CHECKED then
            checkdlgbutton(dialog, 905, BST_UNCHECKED);
          exit;
        end;

        if wparam = 904 then
        begin
          if isdlgbuttonchecked(dialog, 904) = 0 then
          begin
            enablewindow(getdlgitem(dialog, 905), True);
            enablewindow(getdlgitem(dialog, 906), True);
            netonly := False;
          end
          else
          begin
            enablewindow(getdlgitem(dialog, 905), False);
            enablewindow(getdlgitem(dialog, 906), False);
            netonly := True;
          end;

          exit;
        end;

        if wparam = 903 then
        begin
          ora := getdlgitemint(dialog, 901, bo1, False);
          perc := getdlgitemint(dialog, 902, bo2, False);
          if isdlgbuttonchecked(dialog, 905) = bst_checked then
            boot := EWX_REBOOT
          else if isdlgbuttonchecked(dialog, 906) = bst_checked then
            boot := SUSPEND
          else
            boot := EWX_SHUTDOWN or EWX_POWEROFF;
          if (bo1 = False) or (bo2 = False) or (ora > 23) or (perc > 59) then
          begin
            messagebeep(1);
            exit;
          end;

          str(ora, du1);
          str(perc, du2);
          if length(du1) < 2 then
            du1 := '0' + du1;
          if length(du2) < 2 then
            du2 := '0' + du2;

          idat.cbsize := sizeof(_NOTIFYICONDATA);
          {$IFDEF FPC}
          idat.hwnd := globwindow;
          {$ELSE}
          idat.wnd := globwindow;
          {$ENDIF}
          idat.uid := 101;
          idat.uflags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
          idat.ucallbackmessage := 102;
          idat.hicon := loadicon(Hinstance, 'icon_1');
          strpcopy(idat.sztip, 'Shutting Down at ' + du1 + ':' + du2 + ' - Exit by Doubleclicking ');

          if fstart then
          begin
            shell_notifyicona(NIM_ADD, @idat);
            tim := settimer(globwindow, 1, 1000, nil);
            if tim = 0 then
              halt(0);
            fstart := False;
          end
          else
          begin
            shell_notifyicona(NIM_MODIFY, @idat);
          end;

          ShowWindow(dlgmodeless, SW_HIDE);
          Exit;
        end;

        if wparam = ID_Cancel then
        begin
          shell_notifyicona(NIM_DELETE, @idat);
          destroywindow(dlgmodeless);
          destroywindow(globwindow);
          exit;
        end;

      end;
  end;
  config := False;
end;

function windowproc(window: HWND; message:UINT; wparam:WPARAM; lparam:LPARAM ): LRESULT; export; stdcall;

var
  i: integer;
begin
  windowproc := 0;

  case Message of
    WM_Create:
      begin

        //ConfigProc := MakeProcInstance(@Config, HInstance);
        dlgmodeless := createdialog(HInstance, 'AboutBox', window, @config);
        ShowWindow(dlgmodeless, SW_SHOWNORMAL);
        //FreeProcInstance(ConfigProc);

        Exit;
      end;

    102:

      begin

        if (wparam = 101) and (lparam = WM_lbuttondblclk) then
        begin
          shell_notifyicona(NIM_DELETE, @idat);
          destroywindow(dlgmodeless);
          destroywindow(window);
        end;
        if (wparam = 101) and ((lparam = WM_LBUTTONDOWN) or (lparam = WM_RBUTTONDOWN)) then
        begin
          showwindow(dlgmodeless, SW_SHOW);
        end;

        exit;
      end;

    WM_Timer:
      begin
        getlocaltime(syst);

        if (syst.whour = ora) and (syst.wminute = perc) then
        begin
          if netonly = False then
          begin
            if boot <> SUSPEND then
              exitwindowsex(EWX_FORCE or boot, 0)
            else
            begin
              setsystempowerstate(True, True);
              shell_notifyicona(NIM_DELETE, @idat);
              destroywindow(dlgmodeless);
              destroywindow(window);
            end;
          end
          else
          begin
            setlength(re, 10);
            re[0].dwsize := sizeof(TRasEntryNameA);
            lpcb := sizeof(TRasEntryNameA) * 10;
            rasenumentriesa(nil, nil, re, lpcb, lpcentries);

            setlength(rc, lpcentries);
            rc[0].dwsize := sizeof(TRasConnA);
            lpcb := sizeof(TRasConnA) * lpcentries;
            rasenumconnectionsa(rc, lpcb, lpconns);

            for i := 0 to lpconns - 1 do
            begin
              rashangupa(rc[i].hrasconn);
              sleep(3000);
            end;

            shell_notifyicona(nim_delete, @idat);
            destroywindow(dlgmodeless);
            destroywindow(window);
          end;
        end;
        exit;
      end;

    WM_Destroy:
      begin
        killtimer(window, tim);
        postquitmessage(0);
        exit;
      end;
  end;
  windowproc := defwindowproc(Window, Message, WParam, LParam);
end;

{ ----------------------------------------------------------- }

procedure winmain;
var
  top, todump: TTOKENPRIVILEGES;
  intdump: DWORD;
  tokenhan: THandle;
  Message: TMsg;
  wndclass: TWndClass;

begin
  createmutex(nil, True, 'ShutDownWin.exe');
  if getlasterror = error_already_exists then
  begin
    messagebox(0, 'Program already running!', 'ShutdownWin', mb_iconexclamation);
    halt(0)
  end;

  top.privilegecount := 1;
  top.privileges[0].attributes := SE_PRIVILEGE_ENABLED;
  lookupprivilegevaluea(nil, PAnsiChar('SeShutdownPrivilege'), top.Privileges[0].Luid);
  openprocesstoken(getcurrentprocess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, tokenhan);
  adjusttokenprivileges(tokenhan, False, top, sizeof(todump), todump, intdump);

    wndclass.style := CS_HREDRAW or CS_VREDRAW;
    wndclass.lpfnWndProc := @windowproc;
    wndclass.cbClsExtra := 0;
    wndclass.cbWndExtra := 0;
    wndclass.hInstance := HInstance;
    wndclass.hIcon := loadicon(0, IDI_APPLICATION);
    wndclass.hCursor := loadcursor(0, IDC_ARROW);
    wndclass.hbrBackground := getstockobject(BLACK_BRUSH);
    wndclass.lpszMenuName := '';
    wndclass.lpszClassName := OSZTALYNEV;

    if registerclass(wndclass) = 0 then
      halt;

    globwindow := createwindow(OSZTALYNEV,
    'ShutDownWin',
    WS_OVERLAPPED,
    100,
    100,
    100,
    100,
    0,
    0,
    HInstance,
    nil
    );

  while (getmessage(message, 0, 0, 0)) do
  begin
    if not isdialogmessage(dlgmodeless, message) then
    begin
      translatemessage(message);
      dispatchmessage(message);
    end;
  end;
  halt(message.wParam);
end;

{ ----------------------------------------------------------- }

begin
  winmain;
end.

